std::valarray::shift(3)

NAME
std::valarray::shift - std::valarray::shift

Synopsis
   valarray<T> shift( int count ) const;
   Returns a new valarray of the same size with elements whose positions are shifted by
   count elements. The new position of each element is i−count where i is the
   previous position. The value of shifted in elements is T().

Parameters
   count - number of positions to shift the elements by

Return value
   The resulting valarray with shifted elements.

Notes
   The function can be implemented with the return type different from std::valarray.
   In this case, the replacement type has the following properties:
              * All const member functions of std::valarray are provided.
              * std::valarray, std::slice_array, std::gslice_array, std::mask_array and
                std::indirect_array can be constructed from the replacement type.
              * All functions accepting an argument of type const std::valarray&
                except begin() and end()
                (since C++11) should also accept the replacement type.
              * All functions accepting two arguments of type const std::valarray&
                should accept every combination of const std::valarray& and the
                replacement type.
              * The return type does not add more than two levels of template nesting
                over the most deeply-nested argument type.

Example
// Run this code
 #include <iostream>
 #include <valarray>
 int main() {
     std::valarray<int> v{1, 2, 3, 4, 5, 6, 7, 8};
     for (auto const& val : v) {
         std::cout << val << " ";
     }
     std::cout << "\n";
     std::valarray<int> v2 = v.shift(2);
     for (auto const& val : v2) {
         std::cout << val << " ";
     }
     std::cout << "\n";
 }

Output:
 1 2 3 4 5 6 7 8
 3 4 5 6 7 8 0 0

See also
   cshift circular shift of the elements of the valarray
          (public member function)